//Vector2.h


#pragma once

const float PI = 3.141592f;

struct Vector2
{
	float x;
	float y;

	Vector2() :
		x(0.f),
		y(0.f)
	{}

	Vector2(float _x, float _y) :
		x(_x),
		y(_y)
	{}

	Vector2(const Vector2& v) :
		x(v.x),
		y(v.y)
	{}


	void operator = (float f)
	{
		x = f;
		y = f;
	}

	void operator = (const Vector2& v)
	{
		x = v.x;
		y = v.y;
	}

	bool operator == (const Vector2& v)	const
	{
		return (x == v.x && y == v.y);
	}

	bool operator != (const Vector2& v)	const
	{
		return (x != v.x || y != v.y);
	}


	//+
	Vector2 operator + (const Vector2& v)	const
	{
		Vector2 Result;
		Result.x = x + v.x;
		Result.y = y + v.y;
		return Result;
	}
	Vector2 operator + (float f)	const
	{
		Vector2 Result;
		Result.x = x + f;
		Result.y = y + f;
		return Result;
	}
	Vector2 operator + (int i)	const
	{
		Vector2 Result;
		Result.x = x + (float)i;
		Result.y = y + (float)i;
		return Result;
	}
	void operator += (const Vector2& v)
	{
		x += v.x;
		y += v.y;
	}
	void operator += (float f)
	{
		x += f;
		y += f;
	}
	void operator += (int i)
	{
		x += (float)i;
		y += (float)i;
	}




	//-
	Vector2 operator - (const Vector2& v)	const
	{
		Vector2 Result;
		Result.x = x - v.x;
		Result.y = y - v.y;
		return Result;
	}
	Vector2 operator - (float f)	const
	{
		Vector2 Result;
		Result.x = x - f;
		Result.y = y - f;
		return Result;
	}
	Vector2 operator - (int i)	const
	{
		Vector2 Result;
		Result.x = x - (float)i;
		Result.y = y - (float)i;
		return Result;
	}
	void operator -= (const Vector2& v)
	{
		x -= v.x;
		y -= v.y;
	}
	void operator -= (float f)
	{
		x -= f;
		y -= f;
	}
	void operator -= (int i)
	{
		x -= (float)i;
		y -= (float)i;
	}





	//*
	Vector2 operator * (const Vector2& v)	const
	{
		Vector2 Result;
		Result.x = x * v.x;
		Result.y = y * v.y;
		return Result;
	}
	Vector2 operator * (float f)	const
	{
		Vector2 Result;
		Result.x = x * f;
		Result.y = y * f;
		return Result;
	}
	Vector2 operator * (int i)	const
	{
		Vector2 Result;
		Result.x = x * (float)i;
		Result.y = y * (float)i;
		return Result;
	}
	void operator *= (const Vector2& v)
	{
		x *= v.x;
		y *= v.y;
	}
	void operator *= (float f)
	{
		x *= f;
		y *= f;
	}
	void operator *= (int i)
	{
		x *= (float)i;
		y *= (float)i;
	}



	///
	Vector2 operator / (const Vector2& v)	const
	{
		Vector2 Result;
		Result.x = x / v.x;
		Result.y = y / v.y;
		return Result;
	}
	Vector2 operator / (float f)	const
	{
		Vector2 Result;
		Result.x = x / f;
		Result.y = y / f;
		return Result;
	}
	Vector2 operator / (int i)	const
	{
		Vector2 Result;
		Result.x = x / (float)i;
		Result.y = y / (float)i;
		return Result;
	}
	void operator /= (const Vector2& v)
	{
		x /= v.x;
		y /= v.y;
	}
	void operator /= (float f)
	{
		x /= f;
		y /= f;
	}
	void operator /= (int i)
	{
		x /= (float)i;
		y /= (float)i;
	}


};